#include <iostream>
#include "mywindow.h"
#include "createwindow.h"
#include "createwindow2.h"
#include<fstream>
#include<cstdio>
#include<string>
#include<cmath>
#include<gtkmm/filechooserbutton.h>
#include<gtkmm/filechooser.h>
#include<CImg.h>

using namespace cimg_library;
 using namespace std;

struct file
{
string inputfile;
string outputfile;
string imagefile;
string key;
};

struct char_array                                                           //structure to store char array and its length
{
char* data;
long int length;
};

void shift(char array[],int arrraysize);
void swap(char &a,char & b);
void string_to_file(char_array*,string);
char_array *file_to_string(string);                                              //function prototypes
int * convert_char_to_binary(char);
void stego_char_encrypt(CImg<unsigned char>&,char ,int& ,int&,int,int);
void stego_length_encrypt(CImg<unsigned char> &,long int,int &r,int &c,int ,int );
void stego_encrypt(string,string);
void stego_decrypt(string,string);
long int stego_length_decrypt(CImg<unsigned char>&,int&,int&,int,int);
unsigned char stego_char_decrypt(CImg<unsigned char>&,int&,int&,int,int);
void plane_decrypt(string inputfile,string outputfile,string key);
void plane_encrypt(string inputfile,string outputfile,string key);

mywindow::mywindow()
{
    set_default_size(500, 500);
    set_title("STEGO ENCRYPTER");
    set_position(Gtk::WIN_POS_CENTER);

    fixed = new Gtk::Fixed;
    add(*fixed);
    fixed->show();


    Gtk::Label *lusername = Gtk::manage(new Gtk::Label("STEGO ENCRYPTER"));
    fixed->put(*lusername,  160,  110);


    Gtk::Label *lpassword = Gtk::manage(new Gtk::Label("TEAM"));
    fixed->put(*lpassword,  200,  150);

    Gtk::Label *lpasswor = Gtk::manage(new Gtk::Label("C. Vishwesh"));
    fixed->put(*lpasswor,  110,  190);

Gtk::Label *lpasswo = Gtk::manage(new Gtk::Label("Yathansh Kathuria"));
    fixed->put(*lpasswo,  110,  220);

    Gtk::Label *lpassw = Gtk::manage(new Gtk::Label("Rahul Kiran"));
    fixed->put(*lpassw,  110,  250);

    Gtk::Label *lpass = Gtk::manage(new Gtk::Label("140050031"));
    fixed->put(*lpass,  250,  190);

    Gtk::Label *lpas = Gtk::manage(new Gtk::Label("140050021"));
    fixed->put(*lpas,  250,  220);


Gtk::Label *lpa = Gtk::manage(new Gtk::Label("140050071"));
    fixed->put(*lpa,  250,  250);




    Gtk::Button *encrypt = Gtk::manage(new Gtk::Button("Click here to start Encryption"));
    encrypt->signal_clicked().connect(sigc::mem_fun(*this, &mywindow::on_encrypt_click));
    fixed->put(*encrypt,  120,  320);




    Gtk::Button *decrypt = Gtk::manage(new Gtk::Button("Click here to start Decryption"));
    decrypt->signal_clicked().connect(sigc::mem_fun(*this, &mywindow::on_decrypt_click));
    fixed->put(*decrypt,  120,  350);


    Gtk::Button *quit = Gtk::manage(new Gtk::Button("Quit"));
    fixed->put(*quit,  200,  380);






    show_all_children();
}

mywindow::~mywindow()
{
    //dtor
}

void mywindow::on_encrypt_click(){

popup = new createwindow;
popup->show();


}

void mywindow::on_decrypt_click(){

popup2 = new createwindow2;
popup2->show();
}



createwindow::createwindow(){

    set_default_size(500, 500);
    set_title("STEGO ENCRYPTER");
    set_position(Gtk::WIN_POS_CENTER);

    fixed = new Gtk::Fixed;
    add(*fixed);
    fixed->show();


    Gtk::Label *label = Gtk::manage(new Gtk::Label("ENCRYPTION"));
    fixed->put(*label,  200,  10);

    Gtk::Label *inputfile = Gtk::manage(new Gtk::Label("Enter Input File "));
    fixed->put(*inputfile,  90,  70);

    Gtk::Label *outputfile = Gtk::manage(new Gtk::Label("Enter Output File "));
    fixed->put(*outputfile,  90,  130);


    Gtk::Label *imagefile = Gtk::manage(new Gtk::Label("Enter Image File "));
    fixed->put(*imagefile,  90,  190);

    Gtk::Label *key = Gtk::manage(new Gtk::Label("Enter Key "));
    fixed->put(*key,  90,  250);


    Gtk::Entry *enterifile = Gtk::manage(new Gtk::Entry());
    enterifile->set_hexpand(true);
    fixed->put(*enterifile,  210,  70);

    Gtk::Entry *enterofile = Gtk::manage(new Gtk::Entry());
    enterofile->set_hexpand(true);
    fixed->put(*enterofile,  210,  130);


    Gtk::Entry *enterimage = Gtk::manage(new Gtk::Entry());
    enterimage->set_hexpand(true);
    fixed->put(*enterimage,  210,  190);

    Gtk::Entry *enterkey = Gtk::manage(new Gtk::Entry());
    enterkey->set_hexpand(true);
    enterkey->set_visibility(false);
    fixed->put(*enterkey,  210,  250);


    Gtk::Button *startencrypt = Gtk::manage(new Gtk::Button("Encrypt"));
    startencrypt->signal_clicked().connect(sigc::bind<Gtk::Entry*, Gtk::Entry*>(sigc::mem_fun(*this, &createwindow::encrypt),enterifile,enterofile,enterkey));
    fixed->put(*startencrypt,  380,  320);


    Gtk::Button *startsencrypt = Gtk::manage(new Gtk::Button("Stego Encrypt"));
    startsencrypt->signal_clicked().connect(sigc::bind<Gtk::Entry*, Gtk::Entry*>(sigc::mem_fun(*this, &createwindow::sencrypt),enterifile,enterofile ,enterimage,enterkey));
    fixed->put(*startsencrypt, 380,  370);


    show_all_children();
}

createwindow::~createwindow(){}

void createwindow::sencrypt(Gtk::Entry *enterifile,Gtk::Entry *enterofile,Gtk::Entry *enterimage,Gtk::Entry *enterkey)
{file sinput;
sinput.inputfile=enterifile->get_text();
sinput.outputfile=enterofile->get_text();
sinput.key=enterkey->get_text();
sinput.imagefile=enterimage->get_text();

plane_encrypt(sinput.inputfile,sinput.outputfile,sinput.key);
stego_encrypt(sinput.imagefile,sinput.outputfile);

}

void createwindow::encrypt(Gtk::Entry *enterifile,Gtk::Entry *enterofile,Gtk::Entry *enterkey)

{file input;

input.inputfile=enterifile->get_text();
input.outputfile=enterofile->get_text();
input.key=enterkey->get_text();



fstream ifile(input.inputfile.c_str());          //open input file
fstream ofile(input.outputfile.c_str(),ios::in|ios::out);         //open output file
char ch;                                    //to read character
long int length=0;
long int keylength=0;

for(;input.key[keylength]!='\0';keylength++){}                      //to find length of key



ifile.seekg(0,ios::end);
length=(ifile.tellp());
length--;
    cout<<length<<endl;
 int arraysize=floor(sqrt(length))+1;              //find the size of the array

cout<<arraysize<<endl;

ifile.clear();
ifile.seekg(0,ios::beg);

int i=0;
for(int j=0;j<length;j++)                                  //copy contents from input file to output file
    {
    ifile.get(ch);
    ofile.put(char(-ch)+input.key[i]);
    i++;
    if(i==keylength)
        i=0;
    }

/*ofile.clear();
ofile.seekp(0,ios::beg);


for(int j=0;j<length;j++)                                     //First Level of encryption
    {

    ofile.get(ch);
    ofile.seekp(-1,ios::cur);
    cout<<ofile.tellp()<<" ";
    ofile.put(char(256-ch));
    cout<<ch<<" ";
    }



ofile.clear();
ofile.seekp(0,ios::beg);

int i=0;
for(int j=0;j<length;j++)                                  //second level of encryption
    {
    ofile.get(ch);
    ofile.seekp(-1,ios::cur);
    cout<<ofile.tellp()<<" ";
    ofile.put(ch);//+data->key[i]);
    i++;
    if(i==keylength)
        i=0;

    }
*/


/*char array[arraysize][arraysize];                       //create a 2d array to store the text
cout<<"\n\n";

ofile.clear();
ofile.seekg(0,ios::beg);                                //return the get pointer to the beginning of the file

int k=0;
for(int i=0;i<arraysize;i++)                            //store the text in the array and print
   {
    for(int j=0;j<arraysize;j++)
        {
        ofile.get(ch);
        cout<<ch;
        array[i][j]=ch;
        k++;
        if(k==length)
            {
            if(j==arraysize-1)
            array[i+1][0]=char(0);
            else
            array[i][j+1]=char(0);
            break;
            }
        }
    if(k==length)
            {
            break;
            }
   }

cout<<"\n\n";                                      //print array of ofile
for(int i=0;i<arraysize;i++)
    {
    for(int j=0;j<arraysize;j++)
        {
        cout<<int(array[i][j])<<" ";
        }
    cout<<endl;

    }


for(int i=0;i<arraysize;i++)                        //3rd level of encryption shift elements
        {
       for(int j=0;j<i;j++)
       shift(array[i],arraysize);
        }

cout<<"\n\n";                                      //print array of ofile
for(int i=0;i<arraysize;i++)
    {
    for(int j=0;j<arraysize;j++)
        {
        cout<<int(array[i][j])<<" ";
        }
    cout<<endl;

    }

ofile.clear();
ofile.seekg(0,ios::beg);                                //return the get pointer to the beginning of the file
k=0;
for(int i=0;i<arraysize;i++)                           //write contents of array to the  outputfile till the end of file is reached
       {
    for(int j=0;j<arraysize;j++)
        {
        ofile.put(array[i][j]);
        k++;
        if(k==length)
            {
            break;
            }
        }
    if(k==length)
            {
            break;
            }
  }
*/

}


createwindow2::createwindow2()
{

    set_default_size(500, 500);
    set_title("STEGO ENCRYPTER");
    set_position(Gtk::WIN_POS_CENTER);

    fixed = new Gtk::Fixed;
    add(*fixed);
    fixed->show();


    Gtk::Label *label = Gtk::manage(new Gtk::Label("DECRYPTION"));
    fixed->put(*label,  200,  10);

    Gtk::Label *imagefile2 = Gtk::manage(new Gtk::Label("Enter Image File "));
    fixed->put(*imagefile2,  90,  70);

    Gtk::Label *inputfile2 = Gtk::manage(new Gtk::Label("Enter Input File "));
    fixed->put(*inputfile2,  90,  130);

    Gtk::Label *outputfile2 = Gtk::manage(new Gtk::Label("Enter Output File "));
    fixed->put(*outputfile2,  90,  190);

    Gtk::Label *key2 = Gtk::manage(new Gtk::Label("Enter Key "));
    fixed->put(*key2,  90,  250);


    Gtk::Entry *enterimage2 = Gtk::manage(new Gtk::Entry());
    enterimage2->set_hexpand(true);
    fixed->put(*enterimage2,  210,  70);

    Gtk::Entry *enterifile2 = Gtk::manage(new Gtk::Entry());
    enterifile2->set_hexpand(true);
    fixed->put(*enterifile2,  210,  130);

    Gtk::Entry *enterofile2 = Gtk::manage(new Gtk::Entry());
    enterofile2->set_hexpand(true);
    fixed->put(*enterofile2,  210,  190);

    Gtk::Entry *enterkey2 = Gtk::manage(new Gtk::Entry());
    enterkey2->set_hexpand(true);
    enterkey2->set_visibility(false);
    fixed->put(*enterkey2,  210,  250);


    Gtk::Button *startdecrypt = Gtk::manage(new Gtk::Button("Decrypt from file"));
    startdecrypt->signal_clicked().connect(sigc::bind<Gtk::Entry*, Gtk::Entry*>(sigc::mem_fun(*this, &createwindow2::decrypt),enterifile2 ,enterofile2,enterkey2));
    fixed->put(*startdecrypt,  380,  320);
    Gtk::Button *startsdecrypt = Gtk::manage(new Gtk::Button("Decrypt from image"));
    startsdecrypt->signal_clicked().connect(sigc::bind<Gtk::Entry*, Gtk::Entry*>(sigc::mem_fun(*this, &createwindow2::sdecrypt),enterimage2 ,enterofile2,enterkey2,enterifile2));
     fixed->put(*startsdecrypt,  380,  370);

    show_all_children();
}




createwindow2::~createwindow2()
{}



void createwindow2::decrypt(Gtk::Entry *enterifile2,Gtk::Entry *enterofile2,Gtk::Entry *enterkey2)

{file output;

output.inputfile=enterifile2->get_text();
output.outputfile=enterofile2->get_text();
output.key=enterkey2->get_text();


fstream ifile(output.inputfile.c_str());          //open input file
fstream ofile(output.outputfile.c_str(),ios::in|ios::out);         //open output file
char ch;
long int length;
long int keylength=0;

for(;output.key[keylength]!='\0';keylength++){}


ofile.clear();
ofile.seekg(0,ios::beg);

ifile.clear();
ifile.seekg(0,ios::end);
length=(ifile.tellp());
length;                     //get the length of the file

ifile.clear();
ifile.seekg(0,ios::beg);

cout<<length<<endl;

ofile.clear();
ofile.seekg(0,ios::beg);

 int i=0;
for(int j=0;j<length;j++)                                  //copy contents from input file to output file
    {
    ifile.get(ch);
    ofile.put(char(-(ch-output.key[i])));//+data->key[i]);
    i++;
    if(i==keylength)
        i=0;
    }                    //get the length of the file


 /*int arraysize=floor(sqrt(length))+1;              //find the size of the array
cout<<arraysize<<endl;

char array[arraysize][arraysize];

for(int i=0;i<arraysize;i++)                            //store the text in the array
   {
    for(int j=0;j<arraysize;j++)
        {
        ifile.get(ch);

        array[i][j]=ch;
        if(ifile.eof())
            {

            break;
            }
        }
    if(ifile.eof())
            {
            break;
            }
   }


for(int i=0;i<arraysize;i++)
    {
    for(int j=0;j<arraysize;j++)
        {
        cout<<int(array[i][j])<<" ";
        }
    cout<<endl;

    }


for(int i=0;i<arraysize;i++)                        //3rd level of encryption shift elements
        {
       for(int j=0;j<(arraysize-i);j++)
       shift(array[i],arraysize);
        }

 for(int i=0;i<arraysize;i++)
    {
    for(int j=0;j<arraysize;j++)
        {
        cout<<int(array[i][j])<<" ";
        }
    cout<<endl;
    }

ofile.clear();
ofile.seekg(0,ios::beg);
ifile.clear();
ifile.seekg(0,ios::beg);


int j=0;
for(int i=0;i<arraysize;i++)                           //write contents of array to the  outputfile till the end of file is reached
       {
    for(;j<arraysize;j++)
        {
          ofile.put(array[i][j]);
         if(int (array[i][j])==0)
            {
            break;
            }

        }
        if (int(array[i][j])==0)
            {
            break;
            }

   }

ofile.clear();
ofile.seekg(0,ios::beg);
int i=0;
/*while(!ifile.eof())                                 //second level of encryption
    {
    ifile.get(ch);
    ifile.seekp(-1,ios::cur);
    cout<<ifile.tellp()<<" ";
    ifile.put(char(ch)-output.key[i]);
    i++;
    if(i==keylength)
        i=0;

    }

ifile.clear();
ifile.seekg(0,ios::beg);
ofile.clear();
ofile.seekg(0,ios::beg);
int k=0;

while(k<length)

{
ofile.get(ch);

cout<<int(-ch)<<" ";
k++;
}
/*
while(k<=length)                                     //First Level of encryption
    {

    ofile.get(ch);
    ofile.seekg(-1,ios::cur);
    cout<<ofile.tellp()<<" ";
    ofile.put(char(-ch));
    k++;
    }
*/




}

void createwindow2::sdecrypt(Gtk::Entry *enterimage2,Gtk::Entry *enterofile2,Gtk::Entry *enterkey2,Gtk::Entry *enterifile2)
{
file soutput;
soutput.inputfile=enterifile2->get_text();
soutput.outputfile=enterofile2->get_text();
soutput.key=enterkey2->get_text();
soutput.imagefile=enterimage2->get_text();

stego_decrypt(soutput.imagefile,soutput.inputfile);
plane_decrypt(soutput.inputfile,soutput.outputfile,soutput.key);


}

int main(int argc, char *argv[])
{
    Glib::RefPtr<Gtk::Application> app = Gtk::Application::create(argc, argv);

    mywindow window;

    return app->run(window);
}


 void shift(char *array,int arraysize)                       //function to shift elements by 1
{
for(int j=1;j<arraysize;j++)
    swap(array[j],array[j-1]);

}

void swap(char &a,char &b)                                  //function to swap two characters
{

    char temp=a;
    a=b;
    b=temp;
}


char_array *file_to_string(string encryptedfile)
{
    char ch;
    char_array *text=new char_array;
    if(text==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
    long int i=0;
    text->length=0;                                     //and store the text from encrypted file and store in a character array
                                                        // to return the length of the encrypted file
    fstream file(encryptedfile.c_str(),ios::in);

    file.seekg(0,ios::end);
    text->length=(file.tellp());
    text->length--;

    file.clear();
    file.seekp(0,ios::beg);
    char *ptr=new char[text->length];
     if(ptr==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }

     while(!file.eof())
    {
     file.get(ch);
     ptr[i]=ch;
     i++;
    }
    text->data=ptr;
    return text;
}

int * convert_char_to_binary(char ch)
{
    int *binary=new int[8];
     if(binary==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
    int integer=int(ch);                         //functions which returns pointer to the array storing binary code of the input char
    int i=7;
  while(i>=0)
    {
        binary[i]=integer%2;
        integer=integer/2;
        i--;
    }
    return binary;
}

unsigned char  convert_binary_to_char(int * binary)
{

    unsigned char ch=0;
    int num=1;                                  //functions which returns the character which has the binary code of the input array of binary code
   for(int i=7;i>=0;i--)
    {
        ch=ch+num*binary[i];
        num*=2;

    }
    return ch;
    if(binary!=NULL)delete[]binary;
}


int * convert_int_to_binary(long int num)
{
    int *binary=new int[24];
     if(binary==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }                                       //functions which returns pointer to the array storing binary code of the input integer
    int i=23;

  while(i>=0)
    {
        binary[i]=num%2;
        num=num/2;
        i--;
    }
    return binary;
}


long int  convert_binary_to_int(int * binary)
{

    long int  num=0;
    int number=1;                          //functions which returns the integer which has the binary code of the input array of binary code
   for(int i=23;i>=0;i--)
    {
        num=num+number*binary[i];
        number*=2;

    }
    return num;
    if(binary!=NULL)delete[]binary;
}

void stego_char_encrypt(CImg<unsigned char> &img,char ch,int &r,int &c,int width,int height)
{   //cout<<"\n\nstego char encrypt start\n\n";
    int * binary_char;
     if(binary_char==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
    binary_char=convert_char_to_binary(ch);                         //function to implement lsb substitution on one character
    int *binary_pixel;
     if(binary_pixel==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }

    for(int j=0,i=0;j<8;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            binary_pixel=convert_char_to_binary(img(c,r,0,i));

            binary_pixel[7]=binary_char[j];                             //change the lsb of pixel byte
            img(c,r,0,i)=convert_binary_to_char(binary_pixel);

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;
            if(binary_char!=NULL)delete[]binary_char;
            if(binary_pixel!=NULL)delete[]binary_pixel;
            //cout<<"\n\nstego char  encrypt end\n\n";
return;
}

void stego_length_encrypt(CImg<unsigned char> &img,long int length,int &r,int &c,int width,int height)
{    //cout<<"\n\nstego length encrypt start\n\n";
    int * binary_int;
     if(binary_int==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
    binary_int=convert_int_to_binary(length);                         //store the length of the encrypted file in the lsb's at the starting of the file
    int *binary_pixel;
     if(binary_pixel==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }

    for(int j=0,i=0;j<24;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            binary_pixel=convert_char_to_binary(img(c,r,0,i));

            binary_pixel[7]=binary_int[j];
            img(c,r,0,i)=convert_binary_to_char(binary_pixel);

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

            //<<"\n\nstego length encrypt end\n\n";
            if(binary_int!=NULL)delete[]binary_int;
            if(binary_pixel!=NULL)delete[]binary_pixel;
}

void stego_encrypt(string imagefile,string outputfile)
{    cout<<"\n\nstego encrypt start\n\n";
    CImg<unsigned char> src(imagefile.data());
    int width = src.width();
    int height = src.height();
    int c=0,r=0;
//cout<<width<<"x"<<height;
                                                                                    //implement the steganography encryption of the file
    char_array *text=new char_array;
     if(text==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
    text=file_to_string(outputfile);
    //cout<<text->length<<endl;
    stego_length_encrypt(src,text->length,r,c,width,height);

    for(long int i=0;i<text->length;i++)
    {
     stego_char_encrypt(src,text->data[i],r,c,width,height);
    }

    src.display();

     /* CImgDisplay main_disp(src,"Click a point");
  while (!main_disp.is_closed()) {
    main_disp.wait();
  */

  src.save("image.bmp");
  cout<<"\n\nstego encrypt end \n\n";

  if(text!=NULL)delete[] text;
}



long int stego_length_decrypt(CImg<unsigned char> &img,int &r,int& c,int width,int height)
{  // cout<<"\n\nstego length decrypt start\n\n";
     int * binary_int=new int[24];
      if(binary_int==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }
                                                                                //retrive the length of the encrypted file from the lsb's at the starting of the file

    for(int j=0,i=0;j<24;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            if(img(c,r,0,i)%2==0)binary_int[j]=0;
            else binary_int[j]=1;

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

//cout<<"\n\nstego length encrypt end\n\n";
            return convert_binary_to_int(binary_int)    ;
}


unsigned char stego_char_decrypt(CImg<unsigned char> &img,int&r,int&c,int width,int height)
{       //cout<<"\n\nstego char decrypt start\n\n";
    int * binary_char=new int[8];
     if(binary_char==NULL)
        {
            cout<<"Memory unavaliable";
            exit(0);
        }

                                                                               //implement lsb decrytion on 1 character
    for(int j=0,i=0;j<8;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            if(img(c,r,0,i)%2==0)binary_char[j]=0;
            else binary_char[j]=1;

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

       // cout<<"\n\nstego char decrypt end\n\n";
            return convert_binary_to_char(binary_char)    ;
}


void stego_decrypt(string imagefile,string outputfile)
{       cout<<"\n\nstego  decrypt start\n\n";
    CImg<unsigned char> src(imagefile.data());
    int width = src.width();
    int height = src.height();
    int c=0,r=0;
cout<<width<<"x"<<height;
    char_array *text=new char_array;
     if(text==NULL)
        {   cout<<"Memory unavaliable";
            exit(0);                                                            //implement steganography decryption
        }
    //cout<<"\n\nabcd\n\n";
    text->length=stego_length_decrypt(src,r,c,width,height);
    //cout<<"\n\n"<<text->length;
    //cout<<"\n"<<r<<" "<<c;
    for(long int i=0;i<text->length;i++)
    {
     text->data[i]=stego_char_decrypt(src,r,c,width,height);
     //cout<<" "<<text->data[i];
    }
    //cout<<endl;
    for(long int i=0;i<text->length;i++)cout<<text->data[i];
    string_to_file(text,outputfile);
    cout<<"\n\nstego  decrypt end\n\n";
    if(text!=NULL)delete text;

}

void string_to_file(char_array*text,string outputfile)
{
    fstream file(outputfile.c_str(),ios::out);
    for(long int i=0;i<text->length;i++)                                        //store the array to text file
        file<<text->data[i];

}

void plane_decrypt(string inputfile,string outputfile,string key)
{
fstream ifile(inputfile.c_str());          //open input file
fstream ofile(outputfile.c_str(),ios::in|ios::out);         //open output file
char ch;
long int length;
long int keylength=0;

for(;key[keylength]!='\0';keylength++){}


ofile.clear();
ofile.seekg(0,ios::beg);

ifile.clear();
ifile.seekg(0,ios::end);
length=(ifile.tellp());
length;                     //get the length of the file

ifile.clear();
ifile.seekg(0,ios::beg);

cout<<length<<endl;

ofile.clear();
ofile.seekg(0,ios::beg);

 int i=0;
for(int j=0;j<length;j++)                                  //copy contents from input file to output file
    {
    ifile.get(ch);
    ofile.put(char(-(ch-key[i])));//+data->key[i]);
    i++;
    if(i==keylength)
        i=0;
    }                    //get the length of the file
}

void plane_encrypt(string inputfile,string outputfile,string key)
{
fstream ifile(inputfile.c_str());          //open input file
fstream ofile(outputfile.c_str(),ios::in|ios::out);         //open output file
char ch;                                    //to read character
long int length=0;
long int keylength=0;

for(;key[keylength]!='\0';keylength++){}                      //to find length of key



ifile.seekg(0,ios::end);
length=(ifile.tellp());
length--;
    cout<<length<<endl;
 int arraysize=floor(sqrt(length))+1;              //find the size of the array

//cout<<arraysize<<endl;

ifile.clear();
ifile.seekg(0,ios::beg);

int i=0;
for(int j=0;j<length;j++)                                  //copy contents from input file to output file
    {
    ifile.get(ch);
    ofile.put(char(-ch)+key[i]);
    i++;
    if(i==keylength)
        i=0;
    }
}
