#include <iostream>
#include<fstream>
#include<string.h>

using namespace std;

#include <CImg.h>
using namespace cimg_library;

struct file
{
string inputfile;
string outputfile;
string key;
string imagefile;
};


struct char_array                                                           //structure to store char array and its length
{
char* data;
long int length;
};

char_array file_to_string(string);                                              //function prototypes
int * convert_char_to_binary(char);
void stego_char_encrypt(CImg<unsigned char>&,char ,int& ,int&,int,int);
void stego_length_encrypt(CImg<unsigned char> &,long int,int &r,int &c,int ,int );
void stego_encrypt(string,string);
void stego_decrypt(string,string);
long int stego_length_decrypt(CImg<unsigned char>&,int&,int&,int,int);
unsigned char stego_char_decrypt(CImg<unsigned char>&,int&,int&,int,int);

int main()
{
    file* data_encrypt=new file;
    if (data_encrypt==NULL)
    {
        cout<<"error:";
        return -1;
    }

    data_encrypt->imagefile=string("image.bmp");
    data_encrypt->outputfile=string("a.txt");
    cout<<"\n\n1\n\n";
    stego_encrypt(data_encrypt->imagefile,data_encrypt->outputfile);
    cout<<"\n\n2\n\n";
    file* data_decrypt=new file;
    cout<<"\n\n";
    data_decrypt->imagefile=string("image.bmp");
    cout<<"\n\n3\n\n";
    data_decrypt->outputfile=string("c.txt");
    cout<<"\n\n4\n\n";

    stego_decrypt(data_decrypt->imagefile,data_decrypt->outputfile);
    cout<<"\n\n5\n\n";

    return 0;

}

char_array file_to_string(string encryptedfile)
{
    char ch;                                            //function to return the length of the encrypted file
    char_array text;
    long int i=0;
    text.length=0;                                     //and store the text in a character array
    fstream file(encryptedfile.c_str(),ios::in);

    file.seekg(0,ios::end);
    text.length=(file.tellp());
    text.length--;

    file.clear();
    file.seekp(0,ios::beg);
    char *ptr=new char[text.length];


     while(!file.eof())
    {
     file.get(ch);
     ptr[i]=ch;
     i++;
    }
    text.data=ptr;
    return text;
}

int * convert_char_to_binary(char ch)
{
    int *binary=new int[8];
    int integer=int(ch);                         //functions which returns pointer to the array storing binary code of the input char
    int i=7;
  while(i>=0)
    {
        binary[i]=integer%2;
        integer=integer/2;
        i--;
    }
    return binary;
}

unsigned char  convert_binary_to_char(int * binary)
{

    unsigned char ch=0;
    int num=1;                        //functions which returns pointer to the array storing binary code of the input char
   for(int i=7;i>=0;i--)
    {
        ch=ch+num*binary[i];
        num*=2;

    }
    return ch;
}


int * convert_int_to_binary(long int num)
{
    int *binary=new int[24];                                        //functions which returns pointer to the array storing binary code of the input char
    int i=23;

  while(i>=0)
    {
        binary[i]=num%2;
        num=num/2;
        i--;
    }
    return binary;
}


long int  convert_binary_to_int(int * binary)
{

    long int  num=0;
    int number=1;                        //functions which returns pointer to the array storing binary code of the input char
   for(int i=23;i>=0;i--)
    {
        num=num+number*binary[i];
        number*=2;

    }
    return num;
}

void stego_char_encrypt(CImg<unsigned char> &img,char ch,int &r,int &c,int width,int height)
{   cout<<"\n\nstego char encrypt start\n\n";
    int * binary_char;
    binary_char=convert_char_to_binary(ch);                         //implement lsb on 1 character
    int *binary_pixel;

    for(int j=0,i=0;j<8;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            binary_pixel=convert_char_to_binary(img(c,r,0,i));

            binary_pixel[7]=binary_char[j];
            img(c,r,0,i)=convert_binary_to_char(binary_pixel);

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;
            cout<<"\n\nstego char  encrypt end\n\n";
return;                                    //implement lsb on 1 character
}

void stego_length_encrypt(CImg<unsigned char> &img,long int length,int &r,int &c,int width,int height)
{    cout<<"\n\nstego length encrypt start\n\n";
    int * binary_int;
    binary_int=convert_int_to_binary(length);                         //implement lsb on 1 character
    int *binary_pixel;

    for(int j=0,i=0;j<24;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            binary_pixel=convert_char_to_binary(img(c,r,0,i));

            binary_pixel[7]=binary_int[j];
            img(c,r,0,i)=convert_binary_to_char(binary_pixel);

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

            cout<<"\n\nstego length encrypt end\n\n";                                        //implement lsb on 1 character
}

void stego_encrypt(string imagefile,string outputfile)
{    cout<<"\n\nstego encrypt start\n\n";
    CImg<unsigned char> src(imagefile.data());
    int width = src.width();
    int height = src.height();
    int c=0,r=0;
cout<<width<<"x"<<height;

    char_array text=file_to_string(outputfile);
    cout<<text.length<<endl;
    stego_length_encrypt(src,text.length,r,c,width,height);

    for(long int i=0;i<text.length;i++)
    {
     stego_char_encrypt(src,text.data[i],r,c,width,height);
    }

    src.display();

      CImgDisplay main_disp(src,"Click a point");
  while (!main_disp.is_closed()) {
    main_disp.wait();
  }

  src.save("image.bmp");
  cout<<"\n\nstego encrypt end \n\n";
}



long int stego_length_decrypt(CImg<unsigned char> &img,int &r,int& c,int width,int height)
{   cout<<"\n\nstego length decrypt start\n\n";
     int * binary_int=new int[24];
                                                                                //implement lsb on 1 character

    for(int j=0,i=0;j<24;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            if(img(c,r,0,i)%2==0)binary_int[j]=0;
            else binary_int[j]=1;

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

cout<<"\n\nstego length encrypt end\n\n";
            return convert_binary_to_int(binary_int)    ;                           //implement lsb on 1 character
}


unsigned char stego_char_decrypt(CImg<unsigned char> &img,int&r,int&c,int width,int height)
{       cout<<"\n\nstego char decrypt start\n\n";
    int * binary_char=new int[8];
                                                                                //implement lsb on 1 character

    for(int j=0,i=0;j<8;j++,i++)
    {
        if(i==3)
                {
                    i=0;
                    if(c==width-1)
                            {
                                c=0;
                                r++;
                            }

                    else c++;
                }

            if(img(c,r,0,i)%2==0)binary_char[j]=0;
            else binary_char[j]=1;

            }
            if(c==width-1)
                            {
                                c=0;
                                r++;
                            }
            else c++;

        cout<<"\n\nstego char decrypt end\n\n";
            return convert_binary_to_char(binary_char)    ;
}


void stego_decrypt(string imagefile,string outputfile)
{       cout<<"\n\nstego  decrypt start\n\n";
    CImg<unsigned char> src(imagefile.data());
    int width = src.width();
    int height = src.height();
    int c=0,r=0;
cout<<width<<"x"<<height;
    char_array *text=new char_array;

    cout<<"\n\nabcd\n\n";
    text->length=stego_length_decrypt(src,r,c,width,height);
    cout<<"\n\n"<<text->length;
    cout<<"\n"<<r<<" "<<c;
    for(long int i=0;i<text->length;i++)
    {
     text->data[i]=stego_char_decrypt(src,r,c,width,height);
     cout<<" "<<text->data[i];
    }
    puts(text->data);
    cout<<"\n\nstego  decrypt end\n\n";
    return;
}
